; JJ ...some changes must be made in WinMain . Check it out and let me know if you understand why...
.586    
.model flat,stdcall
option casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD
WinMain2    PROTO   :DWORD,:DWORD,:DWORD,:DWORD

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\comctl32.inc
include \masm32\macros\ucmacros.asm

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\comctl32.lib

.const

MainWindowWidth     equ     600
MainWindowHeight    equ     350

.data

hInstance       dd      ?
hMainWindow     dd      ?
WSTR    MainWindowClass,"MainWindowClass"
WSTR    MainWindowName ,"Some Unicode Window"
MainWindowNameOEM   db  sizeof  MainWindowName

wc          WNDCLASSEX  <sizeof wc,CS_HREDRAW+CS_VREDRAW,offset WndProc,NULL,NULL,NULL, \
                        NULL,NULL,COLOR_WINDOW,NULL,offset MainWindowClass,NULL>
OEMFlag     dd      FALSE                        
hStatic     dd      ?
WSTR    StaticClass,"STATIC"
rect        RECT        <>
iccx        INITCOMMONCONTROLSEX    <sizeof iccx,ICC_STANDARD_CLASSES>
                        
.code
    start:
        invoke  GetModuleHandle,NULL
        mov hInstance,eax
        invoke  InitCommonControlsEx,addr iccx
        invoke  WinMain,hInstance,NULL,NULL,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG

    push    hInstance
    pop     wc.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassExW,addr wc
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth/2
    pop     ebx
    ;invoke CharToOemW,addr MainWindowName,addr MainWindowNameOEM ; and change the window's name to this last pointer
    invoke  CreateWindowExW,NULL,addr MainWindowClass,addr MainWindowName,WS_TILEDWINDOW,\   
               eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,CmdShow
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  GetMessageW,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessageW,addr msg
    jmp     msg_loop
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    .if uMsg==WM_DESTROY
        invoke  PostQuitMessage,NULL
	.elseif	uMsg==WM_CREATE
		mov		edi,lParam
		.if	[edi.CREATESTRUCT].hWndParent==NULL
                invoke  GetClientRect,hWnd,addr rect
		    invoke   CreateWindowExW,WS_EX_STATICEDGE,addr StaticClass,NULL,WS_VISIBLE+WS_CHILD+SS_NOTIFY,\
                                0,0,rect.right,20,hWnd,100,hInstance,0
                mov     hStatic,eax                                
                invoke  SendMessageW,hStatic,WM_SETTEXT,NULL,addr MainWindowName
                invoke  CharToOemW,addr MainWindowName,addr MainWindowNameOEM            
		.endif	        	
        .elseif uMsg==WM_COMMAND
            .if word ptr wParam+2==STN_CLICKED
                .if     OEMFlag==TRUE
                    invoke  Beep,200,20
                    invoke  SendMessageW,hStatic,WM_SETTEXT,NULL,addr MainWindowName
                    invoke  SetWindowTextW,hWnd,addr MainWindowName
                    mov     OEMFlag,FALSE
                .else
                    invoke  Beep,400,20
                    invoke  SendMessageW,hStatic,WM_SETTEXT,NULL,addr MainWindowNameOEM
                    invoke  SetWindowTextW,hWnd,addr MainWindowNameOEM
                    mov     OEMFlag,TRUE
                .endif                                        
            .endif                
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor eax,eax
    ret

WndProc     endp

end	start